import os
import re
from abc import ABC, abstractmethod
from typing import List

from checkov.runner_filter import RunnerFilter

IGNORED_DIRECTORIES_ENV = os.getenv('CKV_IGNORED_DIRECTORIES', "node_modules,.terraform,.serverless")

ignored_directories = IGNORED_DIRECTORIES_ENV.split(",")


class BaseRunner(ABC):
    check_type = ""

    @abstractmethod
    def run(self, root_folder, external_checks_dir=None, files=None, runner_filter=RunnerFilter(), collect_skip_comments=True):
        pass


def filter_ignored_directories(d_names, excluded_paths: List[str]):
    excluded_paths = [] if excluded_paths is None else excluded_paths
    [d_names.remove(d) for d in list(d_names) if d in ignored_directories or d.startswith(".")
     or any(re.findall(re.compile(exp), d) for exp in excluded_paths)]
